class Location:
    def __init__(self, place='', lane=''):
        """
        :type place: str
        :type lane: str
        """
        self.place = place
        self.lane = lane

    @staticmethod
    def deserialize(jnode):
        """
        :type jnode: dict
        :rtype: Location
        :raise ModelError:
        """
        place = jnode.get('place', '')
        return Location(place)

    def serialize(self, parent_jnode, jnode_key='location'):
        """
        :type parent_jnode: dict
        :type jnode_key: str
        :rtype: dict
        """
        jnode = {
        }

        if len(self.place):
            jnode['place'] = self.place

        if len(self.lane):
            jnode['lane'] = self.lane

        if len(self.place) or len(self.lane):
            parent_jnode[jnode_key] = jnode

        return parent_jnode
