__all__ = [
    'DB_SECTION',
    'DB_KEY_TESTPACK',
    'mk_test_db_key',
    'mk_test_db_glob',
    'mk_ref',
    'Services',
    'mk_vs_bbox4'
]

from edge.service import db_value
from edge.service import tz


DB_SECTION = '/sys/test'
DB_KEY_TESTPACK = '/'


def mk_vs_bbox4(ui_pid, rn_bbox4):
    """
    :type ui_pid: str
    :type rn_bbox4: list[int] | None
    :rtype: list[int] | None
    """
    if rn_bbox4 is None:
        return None

    from edge import pipeline_helpers as oh

    vs_wh = oh.get_videosource_image_wh(ui_pid, '0')
    rn_wh_dh = oh.get_rn_image_wh_dh(ui_pid, '0')

    if None in [vs_wh, rn_wh_dh]:
        raise Exception

    vs_w, vs_h = vs_wh
    rn_w, rn_h, rn_dh = rn_wh_dh

    scale_factor = vs_w / float(rn_w)
    vs_bbox4 = map(lambda x: int(x * scale_factor), rn_bbox4)
    return vs_bbox4


def mk_test_db_key(session_ref, test_ref):
    """
    :type session_ref: str
    :type test_ref: (str, str)
    :rtype: str
    """
    return '/{}/{test_ref[0]}/{test_ref[1]}'.format(session_ref, test_ref=test_ref)


def mk_test_db_glob(session_ref):
    """
    :type session_ref: str
    :rtype: str
    """
    return '\/{}\/.*'.format(session_ref)


def mk_ref(known_refs=list()):
    """
    :type known_refs: list[str]
    :rtype: str
    """
    # TODO: delete this
    import uuid
    return str(uuid.uuid4())
    #

    refs = set(known_refs)
    ref = len(refs)
    while str(ref) in refs:
        ref += 1

    return str(ref)


class Services:
    def __init__(self, tz_service, db_service):
        """
        :type tz_service: tz.ITzService
        :type db_service: db_value.DbValueApi
        """
        self.tz = tz_service
        self.db = db_service
